<?php

add_event_handler('loc_end_cat_modify', 'travelmap_set_prefilter_cat_modify');
add_event_handler('loc_begin_cat_modify', 'travelmap_cat_modify_submit');

add_event_handler('loc_end_cat_modify', 'travelmap_add_cat_modify_vars_to_template');

function geocode($address)
{
	$address = urlencode($address);
	
	if(!isset($address) || $address=='')
	{
		$data_arr = array(
			'lat' => null,
			'lng' => null
		);
		return $data_arr;
	}
	
	$url = 'http://maps.google.com/maps/api/geocode/json?address=' . $address;
	$resp_json = file_get_contents($url);
	$resp = json_decode($resp_json, true);
	
	if($resp['status']=='OK')
	{
        	$lat = $resp['results'][0]['geometry']['location']['lat'];
        	$lng = $resp['results'][0]['geometry']['location']['lng'];
		
		if($lat && $lng)
		{
			$data_arr = array(
				'lat' => $lat,
				'lng' => $lng
			);
			return $data_arr;
		}
		else
		{
			return false;
		}
	}
	else
	{
		return false;
	}
}

function travelmap_set_prefilter_cat_modify()
{
	global $template;
	$template->set_prefilter('album_properties', 'travelmap_cat_modify');
}

function travelmap_cat_modify($content, &$smarty)
{
	$coordinates = '{if $latitude != \'\' and $longitude != \'\'}{$latitude}, {$longitude}{/if}';
	
	$search = "#<strong>{'Lock'#";

	$replacement = '<p><strong>{\'' . l10n('Location') . '\'|@translate}</strong><br/><input type="text" class="large" name="travelmap_location" value="{$travelmapLocation}" maxlength="255"> ' . $coordinates . '</p><strong>{\'Lock\'';

	return preg_replace($search, $replacement, $content);
}

function travelmap_add_cat_modify_vars_to_template()
{
	global $template;
	
	$cat_id = $_GET['cat_id'];

	load_language('plugin.lang', dirname(__FILE__) . '/../');
	
	$query = '
		SELECT location, latitude, longitude
			FROM ' . TRAVELMAP_TABLE . '
			WHERE category = \'' . pwg_db_real_escape_string($cat_id) . '\'
		;';
	$result = pwg_query($query);
	while ($row = pwg_db_fetch_assoc($result))
	{
		$travelmapLocation = (isset($row['location']) ? $row['location'] : '');
		$latitude = (isset($row['latitude']) ? $row['latitude'] : '');
		$longitude = (isset($row['longitude']) ? $row['longitude'] : '');
	}
	$template->assign(
		array(
			'travelmapLocation' => (isset($travelmapLocation) ? $travelmapLocation : ''),
			'latitude' => (isset($latitude) ? $latitude : ''),
			'longitude' => (isset($longitude) ? $longitude : '')
		)
	);
}

function travelmap_cat_modify_submit()
{
	global $prefixeTable;
	
	if(isset($_POST['submit']) && isset($_POST['travelmap_location']))
	{
		$travelmap_location = $_POST['travelmap_location'];
		$coordinates = geocode($travelmap_location);
		if($coordinates == false)
		{
			sleep(2);
			$coordinates = geocode($travelmap_location);
		}
		if($coordinates != false)
		{
			$lat = $coordinates['lat'];
			$lng = $coordinates['lng'];
		}
		
		$cat_id = $_GET['cat_id'];
		
		if($travelmap_location == '')
		{
			$query = '
				DELETE FROM ' . TRAVELMAP_TABLE . '
					WHERE category = \'' . pwg_db_real_escape_string($cat_id) . '\'
				;';
			pwg_query($query);
		}
		else
		{
			$query = '
				SELECT date_creation FROM ' . IMAGES_TABLE . ', ' . IMAGE_CATEGORY_TABLE . '
					WHERE id = image_id
						AND category_id = \'' . pwg_db_real_escape_string($cat_id) . '\'
						AND date_creation IS NOT NULL
					ORDER BY date_creation
				;';
			$result = pwg_query($query);
			$row = pwg_db_fetch_assoc($result);
			$date = $row['date_creation'];
			
			$query = '
				INSERT INTO ' . TRAVELMAP_TABLE . '
					(category, location, latitude, longitude, date)
					VALUES(\'' . pwg_db_real_escape_string($cat_id) . '\', \'' . pwg_db_real_escape_string($travelmap_location) . '\', \'' . (isset($lat) ? $lat : '') . '\', \'' . (isset($lng) ? $lng : '') . '\', \'' . pwg_db_real_escape_string($date) . '\')
					ON DUPLICATE KEY UPDATE location = \'' . pwg_db_real_escape_string($travelmap_location) . '\', latitude = \'' . (isset($lat) ? $lat : '') . '\', longitude = \'' . (isset($lng) ? $lng : '') . '\', date = \'' . pwg_db_real_escape_string($date) . '\'
				;';
			pwg_query($query);
		}
	}
}
?>